package boosttest;

import org.opencv.core.Core;
import org.opencv.core.CvType;
import org.opencv.core.Mat;
import org.opencv.core.Scalar;
import org.opencv.ml.Boost;
import org.opencv.ml.Ml;

public class BoostTest 
{

    public static void main(String[] args) throws Exception
    {
        System.loadLibrary(Core.NATIVE_LIBRARY_NAME);
        
        Mat data = new Mat(5,3,CvType.CV_32FC1, new Scalar(0));
        
        data.put(0, 0, new float[] {1.69f, 1, 0});
        data.put(1, 0, new float[] {1.76f, 0, 0});
        data.put(2, 0, new float[] {1.80f, 0, 0});
        data.put(3, 0, new float[] {1.77f, 0, 0});
        data.put(4, 0, new float[] {1.83f, 0, 1});
        
        Mat responses = new Mat(5, 1, CvType.CV_32SC1, new Scalar(0));
        
        responses.put(0, 0, new int[]{0, 1, 1, 0, 1});
        
        
        Boost boost = Boost.create();
       
        boost.setBoostType(Boost.DISCRETE);
        boost.setWeakCount(3);
        boost.setMinSampleCount(4);
        
        boost.train(data, Ml.ROW_SAMPLE, responses);
        
        for(int i=0; i<5; i++) {
            System.out.println("Result = " + gender(boost.predict(data.row(i))));
        }
        
        Mat anybody = new Mat(1, 3, CvType.CV_32FC1, new Scalar(0));
        
        anybody.put(0, 0, new float[]{1.60f, 1, 0});
        System.out.println("anybody" + showData(anybody) + gender(boost.predict(anybody)));
        
        anybody.put(0, 0, new float[]{1.80f, 0, 1});
        System.out.println("anybody" + showData(anybody) + gender(boost.predict(anybody)));
        
        anybody.put(0, 0, new float[]{1.70f, 1, 1});
        System.out.println("anybody" + showData(anybody) + gender(boost.predict(anybody)));
        
    }
    
    private static String showData(Mat person)
    {
        float[] data = new float[3];
        person.get(0,0, data);
        String strData = "[ "  +  (data[0] >= 1.76 ? "큰 키" : "작은 키") +
                              ",  " +  (data[1] == 1.0f ? "긴머리" : "짧은머리") + 
                              ",  " +  (data[2] == 1.0f ? "수염있음" : "수염없음") + " ] ";
        return strData;
    }
    
    private static String gender(float x)
    {
        if(x == 0.0f) return "여자";
        else return "남자";
    }
}
